#include <iostream>
#include <vector>
#include <fstream>
#include <time.h>

#include "MersenneTwister.h"
#include "cell.h"
#include "crypt.h"


using namespace std;


int main() {
	Crypt sample[100];
	double sampleSize = 100.0;
	int displayFrequency = 5040; // 1 week = 10080 minutes
	int oneWeek = 10080;
	double sampleMethylationLevel = 0;
	double currentCryptSize = 0, averageCryptSize = 0, minCryptSize = 2000, maxCryptSize = 0;
	int iterMax = 806400; // 80 weeks = 806400 minutes
	int startTime = time(0);
	
	ofstream myfile;
	myfile.open ("outputFile.txt");
	myfile << "Week\t sampleMethylationLevel" << endl;
	// in the current configuration, we save methylation levels, but
	// this can be easily changed to save crypt sizes, as shown in
	// commented sections of the code

	int iter=4300; // in minutes
	while(iter<=iterMax) {
        
        if(iter%(iterMax/20)==0)
            cout << 100*(double)iter/iterMax << " %" << endl;

        // At each time step, we update all crypts in the sample
		for(int i=0; i<100; ++i) {

            // Updating one crypt
			sample[i].Iteration(iter);
			
			// Preparing the output data
			if(iter%displayFrequency==0) { 
				sampleMethylationLevel += sample[i].methylationLevel;
				//currentCryptSize = sample[i].sizeLeft + 7 + sample[i].sizeRight;
				//averageCryptSize += currentCryptSize;
				//if(minCryptSize > currentCryptSize) minCryptSize = currentCryptSize;
				//if(maxCryptSize < currentCryptSize) maxCryptSize = currentCryptSize;
			}
		}
		
		// Writing the output into the file
		if(iter%displayFrequency==0) {
			sampleMethylationLevel = sampleMethylationLevel/sampleSize;
			myfile << (double)iter/displayFrequency << "\t" << sampleMethylationLevel << endl;
			sampleMethylationLevel = 0;
			//averageCryptSize = averageCryptSize/sampleSize;
			//myfile << (double)iter/oneWeek << "\t" << averageCryptSize  << "\t" << minCryptSize  << "\t" << maxCryptSize << endl;
			//averageCryptSize = 0; minCryptSize = 2000; maxCryptSize = 0;
		}
		++iter;
	}
	
	// Simulation completed
	cout << "Simulation completed!" << endl;

	myfile.close();
	return 0;
}

/***************/
/* End of file */
/***************/
