
#ifndef AGENT_H
#define AGENT_H

#include "random.hpp"
#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#define STRAIN_NUMBER 500


typedef int move_t ;

/**************************/
/* Abstract class : Agent */
/**************************/

class Agent
{
   public :
      virtual ~Agent() {};

      move_t getMove() {
         // Computing new direction
         currentDir_ = random_int(0,8);
         return currentDir_;
      };
      
      void setMove(move_t dir) { currentDir_ = dir ;};
      
      int getDest() { return dest_ ; };
      void setDest( int dest ) { dest_ = dest ; };
     
      int getMaxAge() { return maxAge_ ; };
      void setMaxAge( int age ) { maxAge_ = age ; };
      int getDate() { return date_ ; };
      void setDate(int date) { date_ = date; };

      int getI() { return myI_ ; };
      void setI( int inI ) { myI_ = inI ; };
      int getJ() { return myJ_ ; };
      void setJ( int inJ ) { myJ_ = inJ ; };

   protected :
      int date_,maxAge_,dest_;
      move_t  currentDir_;

      int myI_, myJ_;
};

/*******************************/
/* Class Virus for HIV virions */
/*******************************/

class Virus : public Agent
{
   public :
      Virus() {};
      ~Virus() {};
      void setStrain(int strain) {strain_=strain;};
      int getStrain() {return strain_;};
   protected :
      int strain_;
};

/*********************************/
/* Class Th for helper CD4 cells */
/*********************************/

class Th : public Agent
{
   public :
      Th() {};
      ~Th() {};
      void setActive(int activated) {activated_=activated;};
      int getActive() {return activated_;};
      void setClonotype(int clonotype) {clonotype_=clonotype;};
      int getClonotype() {return clonotype_;};
      void setInfected(int infected) {infected_=infected;};
      int getInfected() {return infected_;};
      void setMemory(int memory) {memory_=memory;};
      int getMemory() {return memory_;};
      void setExpansion(int expansion) {expansion_=expansion;};
      int getExpansion() {return expansion_;};
      
      
   protected :
      int activated_;
      int clonotype_;
      int infected_;
      int memory_;
      int expansion_;
};

/************************************/
/* Class Tc for cytotoxic CD8 cells */
/************************************/

class Tc : public Agent
{
   public :
      Tc() {};
      ~Tc() {};
      void setActive(int activated) {activated_=activated;};
      int getActive() {return activated_;};
      void setClonotype(int clonotype) {clonotype_=clonotype;};
      int getClonotype() {return clonotype_;};
      void setExpansion(int expansion) {expansion_=expansion;};
      int getExpansion() {return expansion_;};
      void setMemory(int memory) {memory_=memory;};
      int getMemory() {return memory_;};

   protected :
      int activated_;
      int clonotype_;
      int expansion_;
      int memory_;
};

/******************************************/
/* Class CPA for antigen presenting cells */
/******************************************/

class CPA : public Agent
{
   public :
      CPA() {};
      ~CPA() {};
      int setPresenting(int presenting) {
         int returnValue=0;
         if(presenting1_==0) {
            presenting1_=presenting;
            returnValue=1;
         }
         else {
            if(presenting2_==0) {
               presenting2_=presenting;
               returnValue=2;
            }
            else {
               if(presenting3_==0) {
                  presenting3_=presenting;
                  returnValue=3;
               }
               else {
                  if(presenting4_==0) {
                     presenting4_=presenting;
                     returnValue=4;
                  }
                  else {
                     if(presenting5_==0) {
                        presenting5_=presenting;
                        returnValue=5;
                     }
                  }
               }
            }
         }
         return returnValue;
      };
      void setPresenting1(int presenting) {presenting1_=presenting;};
      void setPresenting2(int presenting) {presenting2_=presenting;};
      void setPresenting3(int presenting) {presenting3_=presenting;};
      void setPresenting4(int presenting) {presenting4_=presenting;};
      void setPresenting5(int presenting) {presenting5_=presenting;};
      int getPresenting() {
         int randomAntigen=random_int(1,5);
         int returnValue=0;
         switch(randomAntigen) {
            case 1:
               returnValue=presenting1_;
               break;
            case 2:
               returnValue=presenting2_;
               break;
            case 3:
               returnValue=presenting3_;
               break;
            case 4:
               returnValue=presenting4_;
               break;
            case 5:
               returnValue=presenting5_;
               break;
         }
         return returnValue;
      };
      int getPresenting1() {return presenting1_;};
      int getPresenting2() {return presenting2_;};
      int getPresenting3() {return presenting3_;};
      int getPresenting4() {return presenting4_;};
      int getPresenting5() {return presenting5_;};
   protected :
      int presenting1_;
      int presenting2_;
      int presenting3_;
      int presenting4_;
      int presenting5_;
};


#endif                        // AGENT_H

/* ------------------------------ End Of File ------------------------------- */
