/* ------------------------ Beginning Of File: cellule.cpp ----------------------- */


#include "cellule.hpp"
#include "agent.hpp"
#include "random.hpp"

#include <stdlib.h>
#include <stdio.h>

#define NBV	20
#define NBTH	10
#define NBTC	10
#define NBCPA	10


Cellule::Cellule() {
   nbcVirus_=0; nbcTh_=0; nbcTc_=0; nbcCPA_=0;
}




/***************************************************************
*                                                              *
*    Cellule::getV()                                           *
*	   returns a pointer to a random virion in                 *
*          the current matrix element                          *
*                                                              *
***************************************************************/

int Cellule::getV() {
   int index=random_int(0,nbcVirus_-1);
   return tabV[index];
}



/***************************************************************
*                                                              *
*    Cellule::flushV()                                         *
*	   delete form the current matrix element the          *
*          virion given as a parameter                         *
*                                                              *
***************************************************************/

void Cellule::flushV(int V_loc) {
   int i=0;
   if(nbcVirus_>1) { // if ==1, no need to flush
   
      // loop to find the agent to delete
      while((i<NBV)&&(tabV[i]!=V_loc)) ++i;
      
      // the agent is replaced by the last element
      tabV[i]=tabV[nbcVirus_-1];
      
      // the number of agents is then reduced by 1 in the main function
   }
}



/***************************************************************
*                                                              *
*    Cellule::getTh()                                          *
*	   returns a pointer to a random Th agent in           *
*          the current matrix element                          *
*                                                              *
***************************************************************/

int Cellule::getTh() {
   int index=random_int(0,nbcTh_-1);
   return tabTh[index];
}



/***************************************************************
*                                                              *
*    Cellule::flushTh()                                        *
*	   delete form the current matrix element the          *
*          Th agent given as a parameter                       *
*                                                              *
***************************************************************/

void Cellule::flushTh(int Th_loc) {
   int i=0;
   if(nbcTh_>1) { // if ==1, no need to flush
   
      // loop to find the agent to delete
      while((i<NBTH)&&(tabTh[i]!=Th_loc)) ++i;
      
      // the agent is replaced by the last element
      tabTh[i]=tabTh[nbcTh_-1];
      
      // the number of agents is then reduced by 1 in the main function
   }
}



/***************************************************************
*                                                              *
*    Cellule::getTc()                                          *
*	   returns a pointer to a random Tc agent in           *
*          the current matrix element                          *
*                                                              *
***************************************************************/

int Cellule::getTc() {
   int index=random_int(0,nbcTc_-1);
   return tabTc[index];
}


/***************************************************************
*                                                              *
*    Cellule::flushTc()                                        *
*	   delete form the current matrix element the          *
*          Tc agent given as a parameter                       *
*                                                              *
***************************************************************/

void Cellule::flushTc(int Tc_loc) {
   int i=0;
   if(nbcTc_>1) { // if ==1, no need to flush
   
      // loop to find the agent to delete
      while((i<NBTC)&&(tabTc[i]!=Tc_loc)) ++i;
      
      // the agent is replaced by the last element
      tabTc[i]=tabTc[nbcTc_-1];
      
      // the number of agents is then reduced by 1 in the main function
   }
}



/***************************************************************
*                                                              *
*    Cellule::getCPA()                                         *
*	   returns a pointer to a random CPA agent in          *
*          the current matrix element                          *
*                                                              *
***************************************************************/

int Cellule::getCPA() {
   int index=random_int(0,nbcCPA_-1);
   return tabCPA[index];
}


/***************************************************************
*                                                              *
*    Cellule::flushCPA()                                       *
*	   delete form the current matrix element the          *
*          CPA agent given as a parameter                      *
*                                                              *
***************************************************************/

void Cellule::flushCPA(int CPA_loc) {
   int i=0;
   if(nbcCPA_>1) { // if ==1, no need to flush
   
      // loop to find the agent to delete
      while((i<NBCPA)&&(tabCPA[i]!=CPA_loc)) ++i;
      
      // the agent is replaced by the last element
      tabCPA[i]=tabCPA[nbcCPA_-1];
      
      // the number of agents is then reduced by 1 in the main function
   }
}

/* ------------------------------ End Of File: cellule.cpp ------------------------------- */
