
#include "strain.hpp"
#include "random.hpp"
#include <cmath>
#include <algorithm>
#include <stdio.h>

#define NOMBRE_EPITOPES_TH 1000
#define NOMBRE_TH_CERTAIN_MAX 10
#define NOMBRE_TH_RANDOM_MAX 15


void Strain::init(int strain_id) {
     
   // Initiliazing strain properties
   prodRate_=(int)random_int(85,115);
   mutationRate_=(int)random_gauss(50,10);
   if(mutationRate_<0) mutationRate_=1;
   ID_=strain_id;

   // Initiliazing the array for "certain" recognition
   int nbCertain=random_int(1,NOMBRE_TH_CERTAIN_MAX);
   if(nbCertain==0) nbCertain=1;
   for(int i=0;i<nbCertain;++i) 
      certain.push_back(random_int(1,NOMBRE_EPITOPES_TH));
   std::sort(certain.begin(),certain.end());

   // Initiliazing the array for "random" recognition
   int nbRandom=random_int(1,NOMBRE_TH_RANDOM_MAX);
   for(int i=0;i<nbRandom;++i)
      random.push_back(random_int(1,NOMBRE_EPITOPES_TH));
   std::sort(random.begin(),random.end());
}


/* ------------------------------ End Of File ------------------------------- */
