#ifndef STRAIN_H
#define STRAIN_H

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <vector>

#include "random.hpp"

#define STRAIN_NUMBER 500
#define FAILED_MUTATION 10

using namespace std;

class Strain
{
   public :
      Strain() {};
      ~Strain() {};
      void init(int);
      
      int getProdRate() {return prodRate_;};
      vector<int> certain;
      vector<int> random;

      int mutation() {
         int strain=ID_;
         int rand=random_int(0,1000);
         if(rand>=mutationRate_) return strain;
         rand=random_int(0,1000);
         if(rand<FAILED_MUTATION) return -1;  
         strain+=(int)random_gauss(0,100);
         if(strain<0) strain+=STRAIN_NUMBER; 
         if(strain>=STRAIN_NUMBER) strain-=STRAIN_NUMBER;
         return (strain);
      };
      
   private :
      int prodRate_, mutationRate_, ID_;

};

#endif

/* ------------------------------ End Of File ------------------------------- */
